/************************************************************************************/
/*  Program name CAPFNDIMP_MENUS.sql                                                */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

ALTER TRIGGER FND_MENUS_CT1 DISABLE;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDIMP_MENUS';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FND_MENUS;

	CURSOR Cur_G IS
	SELECT
		A.*,
		B.Menu_ID_N
	FROM
		CFND_MENUS			A,
		CRST_FND_MENUS_MAP	B
	WHERE	A.Menu_ID	=	B.Menu_ID;

	lv_Next_Seq_ID	NUMBER;

BEGIN

	--  RENAME
	UPDATE
		FND_MENUS
	SET
		MENU_NAME	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(MENU_NAME,1,4),MENU_NAME)
	WHERE	MENU_ID	IN	(
						SELECT
							MENU_ID
						FROM
							CRST_FND_MENUS
						);

	FOR C1 IN Cur_F LOOP
		BEGIN
			SELECT	FND_MENUS_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO CRST_FND_MENUS_MAP VALUES
			(
			C1.MENU_ID,
			C1.MENU_NAME,
			lv_Next_Seq_ID,
			CAPBRIMP_MAPPING.RenameStr(SUBSTR(C1.MENU_NAME,1,4),C1.MENU_NAME)
			);

			INSERT INTO FND_MENUS
			VALUES
			(
			lv_Next_Seq_ID,										--MENU_ID,
			C1.MENU_NAME,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_NAME),		--LAST_UPDATED_BY,
			C1.LAST_UPDATE_LOGIN,
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_NAME),			--CREATED_BY,
			C1.TYPE
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;

	BEGIN
		FOR C2 IN Cur_G LOOP
			INSERT INTO CFND_MENUS VALUES
			(
				C2.Menu_ID_N,
				CAPBRIMP_MAPPING.GetOrgMapping(C2.S_ORG_ID),
				CAPBRIMP_MAPPING.GetBGMapping(C2.S_BUSINESS_GROUP_ID)
			);
		END LOOP;
	EXCEPTION
		WHEN OTHERS THEN
			DBMS_OUTPUT.Put_Line(SQLERRM);
			lv_Err_Count	:=	lv_Err_Count + 1;
	END;

	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/

ALTER TRIGGER FND_MENUS_CT1 ENABLE;
